\LORENZ.XPL	JUL-21-93
\Plots a stereographic 3D image of the Lorenz Attractor.
\ by Loren Blaney

include	\CXPL\CODESI;

integer	I, DLY, CH;
real	X, Y, Z, X1, Y1, Z1, V;
define	T = 0.01;



procedure DOTITLE;	\Clear screen and display title etc.
begin
CLEAR;
RAWTEXT(0, "            L O R E N Z   A T T R A C T O R   


  Ŀ
    Speed: 0 - 9  
    Pause: Enter  
    Clear: Space  
    Exit:  Esc    
   ");

CURSOR(30, 29);
RAWTEXT(0, "Fuse images for 3D. ");
end;	\DOTITLE



procedure RLPOINT(X, Y, Z, C);	\Plot a point in 3D
real	X, Y, Z;		\Coordinates
integer	C;			\Color
define	MAG=6.0, PROX=50, DEPTH=0.06;
begin
POINT(FIX((X+Z*DEPTH)*MAG)+160+PROX, 240-FIX(Y*MAG), C);
POINT(FIX(X*MAG)+480-PROX, 240-FIX(Y*MAG), C);
end;	\RLPOINT



begin	\MAIN
SETVID($12);		\VGA 640x480x16 colors
DOTITLE;
DLY:= 8;		\Set initial plotting speed
X:= 0.6;   Y:= 0.6;   Z:= 0.6;
loop	begin
	X1:= T * 10.0 * (Y-X);		\Lorenz equations
	Y1:= T * (28.*X - Y - X*Z);
	Z1:= T * (X*Y - 8./3.*Z);
	X:= X +X1;   Y:= Y +Y1;   Z:= Z +Z1;

	V:= SQRT(X1*X1 + Y1*Y1 + Z1*Z1);\Color is determined by velocity
	I:= (FIX(V*5.0) + 8) & $0F;
	if I = 0 then I:= 12;		\Don't plot black
	RLPOINT(X, Y, Z, I);

	for I:= 32, 32<<DLY do X1:= X;	\Delay for plotting speed

	if CHKKEY then			\If a key was struck...
		begin
		CH:= CHIN(1);
		case CH of
		  $1B:	quit;		\Esc = Exit
		  $0D:	CH:= CHIN(1);	\Enter = Pause
		  $20:	DOTITLE		\Space = Clear
		other	DLY:= CH & $0F;	\0 - 9 = Speed
		end;
	end;
SETVID($03);		\Restore color text screen
end;	\MAIN
